//*****************************************************************************
//*
//*
//*		RemoveDebugFromLib.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"ObjLib.h"



CDataField  sList(sizeof(int)*2);

//*****************************************************************************
//*
//*		InsertImage
//*
//*****************************************************************************
void InsertImage(int iNr)
{
}

//*****************************************************************************
//*
//*		InsertDown
//*
//*****************************************************************************
void InsertDown()
{
}

//*****************************************************************************
//*
//*		InsertData
//*
//*****************************************************************************
void InsertData(void *pData)
{
}

//*****************************************************************************
//*
//*		InsertUp
//*
//*****************************************************************************
void InsertUp()
{
}

//*****************************************************************************
//*
//*		InsertSort
//*
//*****************************************************************************
void InsertSort(int iSort)
{
}

//*****************************************************************************
//*
//*		InsertTime
//*
//*****************************************************************************/
void InsertTime(const char *Format,long lTimeStamp)
{
}

//*****************************************************************************
//*
//*		InsertFormat
//*
//*****************************************************************************/
void InsertFormat(const char *pFormat, ...)
{
}

//*****************************************************************************
//*
//*		InsertInfo
//*
//*****************************************************************************
void InsertInfo(void *pData,int iType,int iOffset,int iSize)
{
SecEntry   *pSection;
SymEntry   *pSymbol;
int			aData[2];


	switch(iType)
		{
	case OBJ_TYPE_SECTION:

			pSection = (SecEntry*)pData;
			if(memcmp(pSection->name,".debug",6))return;
			break;

	case OBJ_TYPE_SYMBOL:

			pSymbol = (SymEntry*)pData;
			if(memcmp(pSymbol->name,".debug",6))return;
			break;

	default:return;
		}	


	aData[0] = iType;
	aData[1] = iOffset;

	sList.Add(aData);

}

//*****************************************************************************
//*
//*		LibRemoveDebug
//*
//*****************************************************************************
int LibRemoveDebug(const char *pLibName,const char *pNewName)
{
char		cPath[256];
SecEntry   *pSection;
SymEntry   *pSymbol;
const char *pData;
char	   *pNew;
char	   *pPtr;
CMapFile	sMap;
int			iLen;
int			iPos;
int			iRet;


	
		pPtr = sMap.Open(pLibName);							// Bibliothek laden
	if(!pPtr)
		{
		printf("\nDie Datei konnte nicht geladen werden !\n\n");
		return -1;
		}

	iLen = sMap.GetLength();

	LoadInit();
	LoadOptions(0,0x0003);
	
	   iRet=LoadLib(pPtr,iLen,0);							// Bibliothek parsen
	if(iRet)return iRet;

	if(sList.Count()<=0)
		{
		printf("\nEs wurden keine Debug-Informationen gefunden !\n\n");
		return -2;
		}

	pNew = new char[iLen];
	memcpy(pNew,pPtr,iLen);


	for(iPos=0;iPos<sList.Count();iPos++)					// Debug-Abschnitte umbenennen
		{
		pData = pNew+sList.Get(iPos,4);

		switch(sList.Get(iPos,(int)0))
			{
		case OBJ_TYPE_SECTION:

				pSection = (SecEntry*)pData;
				memcpy(pSection->name,".ddddd",6);
				break;

		case OBJ_TYPE_SYMBOL:

				pSymbol = (SymEntry*)pData;
				memcpy(pSymbol->name,".ddddd",6);
				break;
			}	
		}

	
	if(!pNewName)								
		{
		strcpy(cPath,pLibName);
		SetFileType(cPath,"new.lib");
		pNewName = cPath;
		}

	SaveMemory(pNewName,pNew,iLen);							// Genderte Bibliothek speichern

	delete pNew;


return 0;
}
